﻿;; COPY_XD
;; gile
;; https://cadxp.com/topic/23876-copier-les-xdatas-vers-n-entites/?tab=comments#comment-129347
;; 
;; 
;; Copier les xdatas d'un objet source vers des objets cible

(defun c:COPY_XD (/ ss source sdata n apps ent elst cdata)
 (if
   (and
     (setq source (car (entsel "\nSélectionnez l'objet source: ")))
     (setq sdata (cdr (assoc -3 (entget source '("*")))))
   )
    (progn
      (setq n	  -1
     apps (mapcar 'car sdata)
      )
      (princ "\nSélectionnez les objets cible.")
      (if (setq ss (ssget))
 (while	(setq ent (ssname ss (setq n (1+ n))))
   (setq elst  (entget ent '("*"))
	 cdata (cdr (assoc -3 elst))
	 elst  (vl-remove (assoc -3 elst) elst)
   )
   (entmod
     (append elst
	     (list (cons -3
			 (append
			   (vl-remove-if
			     (function
			       (lambda (x)
				 (member (car x) apps)
			       )
			     )
			     cdata
			   )
			   sdata
			 )
		   )
	     )
     )
   )
 )
      )
    )
    (princ
      "\nL'objet séléctionné ne contient pas de données étendues."
    )
 )
 (princ)
)